#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
#############################################################
#                                                           #
#      Copyright @ 2019 -  Osirish Network.                 #
#      All rights reserved.                                 #
#                                                           #
#      osirish                                          #
#                                                           #
#                                                           #
#############################################################
#
#
#  @Author: https://bit.ly/osirish
#

import os
import urllib3
import requests
import sys
import json
import time
import hashlib
from OsirishConfig import __version__, cache_dir, configuration
from OsirishUtils import creation_date, createDir

# Disable warning
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

# Pickel For Caching
try:
    import cPickle as pickle

except:
    import pickle
    
class OsirishAPI:
    def __init__(self, **Osirish):
        self.a = None
        self.b = []
        self.d = ""
        if "token" in Osirish:
            self.d = Osirish['token']
            
        self.e = {
            "X-Osirish-Auth": self.d,
            'User-agent': 'Osirish-APP ' + __version__

        }
        self.f = None
        self.OsirishAPI = 'url' in Osirish and Osirish['url'] or configuration['root'] + "/callback/cli/python/v1/"
        self.rtr = 0
        self.cache = False
        self.cache_path = cache_dir + "/Osirish Network API"
        if "cache" in Osirish:
            if Osirish['cache']:
                self.cache = True
                createDir(self.cache_path)

    def parse(self):
        try:
            d = json.loads(self.text())
            if "status" in d and type(d) is dict:
                if d['status'] == "OK":
                    if type(d['data']) is dict or type(d['data']) is list:
                        return d['data']
            return {}

        except(KeyboardInterrupt, SystemExit):
            sys.exit(0)
            
        except:
            return {}
            
        return {}

    def code(self):
        return self.f.status_code

    def text(self):
        return self.f.text.encode(self.f.encoding is None and self.f.encoding or 'UTF-8', 'ignore').decode('UTF-8')

    def json(self):
        return json.loads(self.text())

    def get(self, a, b = None):
        try:
            if self.cache == True and b is None:
                z = self.cache_path + "/" + hashlib.md5((self.OsirishAPI + "/" + a).encode()).hexdigest()
                if (time.time() - creation_date(z)) < (60 * 60):
                    with open(z, 'rb') as input:
                        self.f = pickle.load(input)
            if self.f is None:
                if b is None:
                    self.f = requests.get(self.OsirishAPI + "/" + a, verify=False, headers=self.e)
                
                else:
                    self.f = requests.post(self.OsirishAPI + "/" + a, data=b, verify=False, headers=self.e)

            if "osirish.club/api" in self.OsirishAPI or "://engine" in self.OsirishAPI:
                _test_ = self.json()
                del _test_
            
            if self.cache == True and b is None:
                with open(z, 'wb') as output:  # Overwrites any existing file.
                    pickle.dump(self.f, output, pickle.HIGHEST_PROTOCOL)

        except(KeyboardInterrupt, SystemExit):
            sys.exit(0)
            
        except:
            self.rtr += 1
            if self.rtr > 15:
                print("No connection cloud be made!")

            else:
                return self.get(a,b)

        return self