#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
#############################################################
#                                                           #
#      Copyright @ 2019 -  Osirish Network.                 #
#      All rights reserved.                                 #
#                                                           #
#      osirish                                          #
#                                                           #
#                                                           #
#############################################################
#
#
#  @Author: https://bit.ly/osirish
#


import os
import json

from OsirishUtils import createDir, getFile, putFile

__author__ = 'Osirish Network'
__license__ = 'MIT'
__version__ = '1.8'
__folder__ = "/.osirish"

if os.path.isdir(os.path.expanduser("~")):
    cwd = os.path.realpath(os.path.expanduser("~") + __folder__)
    
else:
    cwd = os.path.realpath(os.getcwd() + __folder__)

cache_dir = cwd + "/cache"
auth_api = cwd + "/auth.key"
plugins_dir = cwd + "/plugins"
config_file = cwd + "/config.json"

createDir(cwd)
createDir(cache_dir)
createDir(plugins_dir)

configuration = {
    "root": "https://www.osirish.club",
    "checker": {
        "format": "%reason% | %proxy% | %resource% | %info% | [CRE:%credits%] [CHECKED ON: HTTPS://OSIRISH.CO]",
        "allow_whitespace": False,
        "timeout": 30,

    },
    "plugins": {
        "repository": [
            "https://www.osirish.club/dl/python/"

        ]
    },
}
# if not os.path.isfile(config_file):
#     putFile(config_file, json.dumps(configuration, sort_keys=True, indent=4))
# try:
#     a = json.loads(getFile(config_file))
# except:
#     a = {}
# configuration.update(a)
# putFile(config_file, json.dumps(configuration, sort_keys=True, indent=4))