#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
#############################################################
#                                                           #
#      Copyright @ 2019 -  Osirish Network.                 #
#      All rights reserved.                                 #
#                                                           #
#      Osirish Team                                         #
#                                                           #
#                                                           #
#############################################################
#
#
#  @Author: osirish.net@gmail.com
#

import colorama
import urllib3
import requests
import sys
import json
import random
import time
import io

from OsirishUtils import putFile
from colorama import coloramaInit, Fore, Style

urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

class OsirishMachine:
    def __init__(self, **a):
        self.b = 'id' in a and a['id'] or 0
        self.d = 'resource' in a and a['resource'] or []
        self.c = len(self.d)
        self.f = 'engine' in a and a['engine'] or []
        self.g = 'token' in a and a['token'] or ''
        self.h = "options" in a and a['options'] or {}
        self.cfg = "configuration" in a and a['configuration'] or {}
        self.i = 'cid' in a and a['cid'] or ''
        self.j = 'result_dir' in a and a['result_dir'] or ''
        self.k = 'format' in self.cfg and self.cfg['format'] or "%reason% | %proxy% | %resource% | %info% | [CRE:%credits%] [CHECKED ON: HTTPS://OSIRISH.CO]"
        self.rts = 0
        self.e = 30
        self.mid = 'mid' in a and a['mid'] or ''
        self.y = 'user' in a and a['user'] or []
        self.z = 'delim' in a and a['delim'] or ''
        if "timeout" in a:
            self.e = a['timeout']
        
    def push_result(self, **a):
        if self.j != "":
            return putFile(self.j + "/" + a['status'] + ".txt", a['data'] + "\n", 'a+')

    def resultType(self, a):
        if a == "PROXY_PROBLEM":
            return "Proxy Dead"
        
        elif a == "UNKNOWN/WRONG":
            return "Unknown"

        else:
            return a

    def start(self):
        coloramaInit(autoreset=True)
        a = 0 # On Line
        mr = -1 # Max Retry
        while a < self.c:
            try:
                # Max Retry
                mr += 1

                # Set Machine State
                self.rts = 0
                b = self.d[a]

                # Config
                c = json.dumps({
                    'checker': {
                        'version': 2,
                        'machineId': self.mid,
                        'sessionId': self.mid,

                    },
                    'resource': {
                        'value': b,
                        'delimiter': self.z,
                        'hash': (self.h.hash is not None and self.h.hash or "plain"),
                        'total': 1,
                        'current': 1,
                        'allow_whitespace': ("allow_whitespace" in self.cfg and self.cfg["allow_whitespace"] or False),

                    },
                    'proxy': {
                        'auto': True,
                        'timeout': self.e,

                    },
                    'option': {
                        'cookies': '',
                        'CheckAllData': True,
                        'format': self.k,
                        'cache': True,
                        'html': False,

                    },
                })
                engine = random.choice(self.f)
                
                # Start Check
                e = requests.post(engine + '/checker/start/' + self.i, data=c, verify=False, headers={'X-Osirish-Auth': self.g}, timeout=3600).text.encode('UTF-8', 'ignore').decode('UTF-8')
                d = json.loads(e)
                
                # Check State
                if d['status'] == "WAIT":
                    pass

                elif d['status'] == "DIE":
                    a += 1
                    mr = 0
                    print(Fore.RED + Style.DIM + "DIE" + Style.RESET_ALL + " | " + d['msg'])
                    self.push_result(status=d['status'], data="DIE | " + d['msg'])

                elif d['status'] == "LIVE":
                    a += 1
                    mr = 0
                    print(Fore.GREEN + Style.DIM + "LIVE" + Style.RESET_ALL + " | " + d['msg'])
                    self.push_result(status=d['status'], data="LIVE | " + d['msg'])

                elif d['status'] == "NO_LOGIN":
                    print("No login detected! please relogin.")
                    break

                elif d['status'] == "RECONNECT":
                    pass

                elif d['status'] == "PUSH_MESSAGE":
                    print("MESSAGE" + Style.RESET_ALL + " | " +  d['msg'])
                    pass
                    
                elif d['status'] == "PROXY_PROBLEM":
                    pass

                else:
                    print(Fore.RED + Style.DIM + "ERROR" + Style.RESET_ALL + " | " + b)
                    if "max_retry" in self.h:
                        if mr > self.h.max_retry and self.h.max_retry > 0:
                            mr = 0
                            a += 1
                        
            except (KeyboardInterrupt, SystemExit):
                print("Closing machine {}...".format(self.b))
                sys.exit(0)
                # break

            # except (AttributeError, ValueError): #json.decoder.JSONDecodeError
            #     pass

            except Exception as exy:
                print('Failed when checking: ' + str(exy))
                if self.y['admin']: print(e)
                self.rts += 1
                if self.rts > 5:
                    a += 1

                else:
                    time.sleep(self.rts * 2)