#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
#############################################################
#                                                           #
#      Copyright @ 2019 -  Osirish Network.                 #
#      All rights reserved.                                 #
#                                                           #
#      osirish                                          #
#                                                           #
#                                                           #
#############################################################
#
#
#  @Author: https://bit.ly/osirish
#

import os
import sys
import json
import re
import getpass
import io
import platform
import random
import string
from colorama import coloramaInit, Fore, Style
coloramaInit(autoreset=True)

# Python Older Version
try:
    input = raw_input

except:
    pass

def myexcepthook(exctype, value, traceback):
    for p in multiprocessing.active_children():
       p.terminate()

def createDir(a):
    if not os.path.exists(a):
        return os.makedirs(a)
    return True

def getFile(a):
    if os.path.isfile(a):
        b = io.open(a, 'r', encoding="utf-8", errors='replace')
        c = b.read()
        b.close()
        return c
    putFile(a, '')
    return ''

def deleteFile(a):
    if os.path.isfile(a):
        os.remove(a)
        return True
    return True

def putFile(a, b, mode = 'w'):
    c = io.open(a, mode)
    try:
        d = c.write(b.decode('utf-8'))

    except:
        d = c.write(b)

    c.close()
    return d
    
def getInput(a, b = None, **d):
    try:
        sys.stdout.write(a)
        sys.stdout.flush()
        c = d.pop('prefix', '') + str(input()).replace("\r", "").replace("\n", "")
        if b is None: return c
        if callable(b):
            if b(c):
                return c

            else:
                print("Invalid data provided")
                return getInput(a, b)            
        
        else:
            if re.match(b, c):
                return c

            else:
                print("Invalid data provided")
                return getInput(a, b)

    except(KeyboardInterrupt, SystemExit):
        sys.exit(0)

    except:
        return getInput(a, b)

def getMenu(a, b = [], **kwargs):
    try:
        if "input_only" not in kwargs:
            print(Fore.CYAN + a) #Osirish Network " + ('-' * int(round(len(a) / 1.1))) + "\r\n" +
            if a[:7] != "Welcome" and "authenticate" not in a: print("0. Back to home")

            for c, d in enumerate(b):
                print(str(c + 1) + ". " + b[c]['name'])

        z = Fore.CYAN + ("text" in kwargs and kwargs['text'] or "Choose your input: ")
        e = int(getInput(z, r"^[0-9]{0,10}$"))
        if e == 0 and (a[:7] != "Welcome" and "authenticate" not in a):
            return False
            
        return b[e-1]['id']
        
    except(KeyboardInterrupt, SystemExit):
        sys.exit(0)

    except:
        return getMenu(a, b, input_only=True)

def creation_date(path_to_file):
    """
    Try to get the date that a file was created, falling back to when it was
    last modified if that isn't possible.
    See http://stackoverflow.com/a/39501288/1709587 for explanation.
    """
    try:
        if platform.system() == 'Windows':
            return os.path.getctime(path_to_file)
        else:
            stat = os.stat(path_to_file)
            try:
                return stat.st_birthtime
                
            except AttributeError:
                # We're probably on Linux. No easy way to get creation dates here,
                # so we'll settle for when its content was last modified.
                return stat.st_mtime
                
    except:
        return 0

def id_generator(size=6, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size))